000100000000                        /* Create program index from program text */
000200000000             PGM        &PLIB
000300000000
000400900830         /* &PLIB is the library to create the index for      */
000500900830         /* &PGMLIB is the library where the utility resides  */
000600900830         /*         Customize for your site.                  */
000700900830         /* &FILLIB is the library where the utility's        */
000800900830         /*         data resides.  Customize for your site.   */
000900000000             DCL        &PLIB *CHAR 10
001000880307             DCL        &PGMLIB *CHAR 10 'SOFPGM'
001100880307             DCL        &FILLIB *CHAR 10 'SCSFILES'
001200880822
001300900830         /* &MSGID and &MSGDTA are for error messages.        */
001400900830         /* &U1 is a flag to store the status of UPSI 1       */
001500900830         /* &CPFLVL is a field used to check the Operating    */
001600900830         /*         System level.  The code in program        */
001700900830         /*         CRTPGMINDR may change with different      */
001800900830         /*         releases of the operating system.         */
001900880822             DCL        &MSGID *CHAR 7
002000880822             DCL        &MSGDTA *CHAR 256
002100880822             DCL        &U1 *CHAR 1
002200881029             DCL        &CPFLVL *CHAR 750   /* CPF level check */
002300880822
002400900830         /* Trap all errors, and let the error routine handle */
002500880822             MONMSG     (CPF0000 MCH0000) EXEC(GOTO ERROR)
002600000000
002700900830         /* This is a "CPF Level check."  This routine will   */
002800900830         /* issue an error if the OS level changes.  It       */
002900900830         /* retrieves a data area which is shipped with the   */
003000900830         /* system, and compares the release level found      */
003100900830         /* there with the release level when this CL program */
003200900830         /* was compiled.  If there is a difference, or if    */
003300900830         /* the data area cannot be accessed, the OS level is */
003400900830         /* assumed to have changed.  When this happens,      */
003500900830         /* simply DSPDTAARA Q5728SS1.QSYS and place the      */
003600900830         /* release level in the IF statement below.          */
003700911219             RTVDTAARA  Q5738SS1.QSYS &CPFLVL
003800911219             MONMSG     CPF0000 EXEC(GOTO TRYV1)
003900911219             IF         (%SST(&CPFLVL 1 6) *EQ 'V2R1M0') (GOTO CPFLVLOK)
004000921214             IF         (%SST(&CPFLVL 1 6) *EQ 'V2R2M0') (GOTO CPFLVLOK)
004100941024             IF         (%SST(&CPFLVL 1 6) *EQ 'V3R0M5') (GOTO CPFLVLOK)
004200911219 TRYV1:
004300881029             RTVDTAARA  Q5728SS1.QSYS &CPFLVL
004400000000             MONMSG     CPF0000 EXEC(GOTO CPFLVLBAD)
004500900302             IF         (%SST(&CPFLVL 1 6) *EQ 'R02M00') +
004600000000                          (GOTO CPFLVLOK)
004700910617             IF         (%SST(&CPFLVL 1 6) *EQ 'R03M00') +
004800910617                          (GOTO CPFLVLOK)
004900000000 CPFLVLBAD:  SNDPGMMSG  MSG('Programming: Check the CPF level') +
005000000000                          TOPGMQ(*EXT)
005100000000
005200000000 CPFLVLOK:              /* CPF level matches */
005300900830         /* This program sends status messages to show the    */
005400900830         /* progress of the various routines.                 */
005500900830         /*   This will capture the information about each    */
005600900830         /* program object in the specified library.  The     */
005700900830         /* output is directed to file DSPOBJD.QTEMP          */
005800880822             SNDPGMMSG  MSGID(CPF9898) MSGF(QCPFMSG) MSGDTA('Creating +
005900880822                          program index for library ' *CAT &PLIB +
006000880822                          *TCAT '.  Retrieving program information') +
006100880822                          TOPGMQ(*EXT) MSGTYPE(*STATUS)
006200000000             DSPOBJD    OBJ(*ALL.&PLIB) OBJTYPE(*PGM) OUTPUT(*NONE) +
006300000000                          OUTFILE(DSPOBJD.QTEMP)
006400000000
006500900830         /* This routine clears the index file, or if needed  */
006600900830         /* creates the member.  For each library that you    */
006700900830         /* run CRTPGMIND against, a member in file PGMIND is */
006800900830         /* used to store the index information.  If you      */
006900900830         /* remove a library from the system and want to      */
007000900830         /* release the storage from this file, simply do a   */
007100900830         /* RMVM PGMIND MBR(deleted_library_name)             */
007200880822             SNDPGMMSG  MSGID(CPF9898) MSGF(QCPFMSG) MSGDTA('Creating +
007300880822                          program index for library ' *CAT &PLIB +
007400880822                          *TCAT '.  Setting up index file') +
007500880822                          TOPGMQ(*EXT) MSGTYPE(*STATUS)
007600880307             CLRPFM     PGMIND.&FILLIB &PLIB
007700000000             MONMSG     CPF0000 EXEC(DO)
007800880307                        ADDPFM     PGMIND.&FILLIB &PLIB
007900000000                        ENDDO
008000000000
008100900830         /* This routine does the "work."  It OVRDBF's the    */
008200900830         /* files for the RPG program's use, stores the state */
008300900830         /* of UPSI 1 and calls the RPG program to pass       */
008400900830         /* through the DSPOBJD file and create the actual    */
008500900830         /* index entries.  Then UPSI 1 is restored to it's   */
008600900830         /* previous state.                                   */
008700900830         /*   UPSI 1 is used if you want to print statistics  */
008800900830         /* about the library and it's index.  If you want    */
008900900830         /* to see this list, on the CHGJOB command, make the */
009000900830         /* forst UPSI a 1.  Make it a 0 for no list.         */
009100880822             SNDPGMMSG  MSGID(CPF9898) MSGF(QCPFMSG) MSGDTA('Creating +
009200880822                          program index for library ' *CAT &PLIB +
009300880822                          *TCAT '.  Generating keywords') +
009400880822                          TOPGMQ(*EXT) MSGTYPE(*STATUS)
009500000000             OVRDBF     DSPOBJD DSPOBJD.QTEMP SEQONLY(*YES 100)
009600880307             OVRDBF     PGMIND PGMIND.&FILLIB &PLIB
009700880822                        /* Save the state of U1, then set switch */
009800880822                        /*      U1 - print statistics            */
009900880822             CHGVAR     &U1 '0'
010000880822             IF         %SWITCH(1XXXXXXX) (CHGVAR &U1 '1')
010100900830             CHGJOB     SWS(0XXXXXXX)   /* Statistics ??? */
010200880307             CALL       CRTPGMINDR.&PGMLIB
010300880822             SNDPGMMSG  MSGID(CPF9898) MSGF(QCPFMSG) MSGDTA('Creating +
010400880822                          program index for library ' *CAT &PLIB +
010500880822                          *TCAT '.  Terminating') TOPGMQ(*EXT) +
010600880822                          MSGTYPE(*STATUS)
010700880822                        /* Restore U1 to previous state */
010800880822             IF         (&U1 *EQ '0') (CHGJOB SWS(0XXXXXXX))
010900000000
011000900830         /* Clean up and return to caller                     */
011100880822 END:        DLTOVR     *ALL
011200000000             RCLRSC
011300000000             RETURN
011400880822
011500900830         /* This is the error handling routine.  Basically it */
011600900830         /* simply re-sends the messages back up to the       */
011700900830         /* caller, so it dies "gracefully" instead of        */
011800900830         /* giving a hard halt.                               */
011900880822                        /* Re-send diagnostic messages */
012000880822 ERROR:      RCVMSG     MSGTYPE(*DIAG) MSGDTA(&MSGDTA) MSGID(&MSGID)
012100880822             IF         (&MSGID *EQ '       ') GOTO ERROR_ESC
012200880822             SNDPGMMSG  MSGID(&MSGID) MSGF(QCPFMSG) MSGDTA(&MSGDTA) +
012300880822                          MSGTYPE(*DIAG)
012400880822             MONMSG     (CPF0000 MCH0000)
012500880822             GOTO       ERROR
012600880822
012700880822                        /* Re-send escape message and RETURN */
012800880822 ERROR_ESC:  RCVMSG     MSGTYPE(*EXCP) MSGDTA(&MSGDTA) MSGID(&MSGID)
012900880822             SNDPGMMSG  MSGID(&MSGID) MSGF(QCPFMSG) MSGDTA(&MSGDTA) +
013000880822                          MSGTYPE(*ESCAPE)
013100880822             MONMSG     (CPF0000 MCH0000)
013200880822             RETURN
013300880822
013400000000             ENDPGM
